"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const client_socket_manager_1 = require("@tapsioss/client-socket-manager");
const React = __importStar(require("react"));
const constants_ts_1 = require("./constants.js");
const Context_ts_1 = require("./Context.js");
const __SINGLETON_REFS__ = {};
const SocketClientProvider = (props) => {
    var _a;
    const { children, uri, ...options } = props;
    const [clientInstance, setClientInstance] = React.useState((_a = __SINGLETON_REFS__[uri]) !== null && _a !== void 0 ? _a : null);
    const [connectionStatus, setConnectionStatus] = React.useState(constants_ts_1.ConnectionStatus.DISCONNECTED);
    React.useEffect(() => {
        var _a;
        if (!__SINGLETON_REFS__[uri]) {
            const client = new client_socket_manager_1.ClientSocketManager(uri, {
                ...options,
                eventHandlers: {
                    ...((_a = options.eventHandlers) !== null && _a !== void 0 ? _a : {}),
                    onSocketConnection() {
                        var _a, _b;
                        (_b = (_a = options.eventHandlers) === null || _a === void 0 ? void 0 : _a.onSocketConnection) === null || _b === void 0 ? void 0 : _b.call(client);
                        setConnectionStatus(constants_ts_1.ConnectionStatus.CONNECTED);
                    },
                    onSocketDisconnection(reason, details) {
                        var _a, _b;
                        (_b = (_a = options.eventHandlers) === null || _a === void 0 ? void 0 : _a.onSocketDisconnection) === null || _b === void 0 ? void 0 : _b.call(client, reason, details);
                        setConnectionStatus(constants_ts_1.ConnectionStatus.DISCONNECTED);
                    },
                    onReconnecting(attempt) {
                        var _a, _b;
                        (_b = (_a = options.eventHandlers) === null || _a === void 0 ? void 0 : _a.onReconnecting) === null || _b === void 0 ? void 0 : _b.call(client, attempt);
                        setConnectionStatus(constants_ts_1.ConnectionStatus.RECONNECTING);
                    },
                },
            });
            setClientInstance(client);
            __SINGLETON_REFS__[uri] = client;
        }
        else {
            throw new Error([
                `ClientSocketManager: An active client already exists for the URI "${uri}".`,
                "Multiple clients for the same URI are not allowed.",
            ].join(" "));
        }
        return () => {
            if (__SINGLETON_REFS__[uri]) {
                __SINGLETON_REFS__[uri].dispose();
                __SINGLETON_REFS__[uri] = null;
            }
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const ctx = React.useMemo(() => ({
        connectionStatus,
        get socket() {
            if (!clientInstance)
                return null;
            if (clientInstance.disposed)
                return null;
            return clientInstance;
        },
    }), [connectionStatus, clientInstance]);
    return ((0, jsx_runtime_1.jsx)(Context_ts_1.SocketContext.Provider, { value: ctx, children: children }));
};
exports.default = SocketClientProvider;
